﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Data;
using C1.WPF.FlexGrid;
using System.Linq;
using System.Windows.Media;

namespace GroupPanel
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly ObservableCollection<Product> _products=new ObservableCollection<Product>();
        private List<Product> _list;
        private List<Product> _list2;
        private bool _listSelect;
        List<string> DefineRows;
        List<Item> items;
        public MainWindow()
        {
            InitializeComponent();
            DefineRows = new List<string>();
            items = new List<Item>();

            // create a data source
            _list = new List<Product>();
            _list2=new List<Product>();
            for (int i = 0; i < 200; i++)
            {
                _list.Add(new Product());
            }
            for (int i = 0; i < 10; i++)
            {
                _list2.Add(new Product());
            }
            foreach (var item in _list)
            {
                _products.Add(item);
            }
            _flex.ItemsSource = _products;
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Refresh();
        }
        private void Refresh()
        {
            SaveExpandedRows();
            // get new data 
            _products.Clear();

            _listSelect = !_listSelect;

            List<Product> list;

            if (_listSelect)
                list = _list;
            else
                list = _list2;

            foreach (var item in list)
            {
                _products.Add(item);
            }
            for (int i = 0; i <= _flex.Rows.Count - 1; i++)
            {
                RestoreExpandedRows(i);
            }
        }
        private void SaveExpandedRows()
        {
            items.Clear();
            int count = 0;
            for (int i = 0; i <= _flex.Rows.Count - 1; i++)
            {
                Item itm = new Item();
                if (_flex.Rows[i] is GroupRow)
                {
                    itm.Name = ((GroupRow)_flex.Rows[i]).Group.Name.ToString();
                    itm.IsCollapsed = ((GroupRow)_flex.Rows[i]).IsCollapsed;
                    if (items.Count > 0 && ((GroupRow)_flex.Rows[i]).Level > items[items.Count-1].Level)
                    {
                        itm.Level = ((GroupRow)_flex.Rows[i]).Level;
                        items[items.Count - 1].subItems.Add(itm);
                    }
                    else
                    {
                        this.items.Add(itm);
                        count++;
                    }
                }
            }
        }
        private void RestoreExpandedRows(int i)
        {
             if (_flex.Rows[i] is GroupRow)
             {
                  GroupRow gr = (GroupRow)_flex.Rows[i];
                  if(gr!=null)
                  {
                       for(int j=0; j<items.Count;j++)
                       {
                           if(gr.Level==items[j].Level && (gr.Group.Name.ToString() == items[j].Name))
                           {
                               gr.IsCollapsed = items[j].IsCollapsed;
                               return;
                           }
                           else if(gr.Level > items[j].Level)
                           {
                               foreach(Item subItem in items[j].subItems)
                               {
                                  if (gr.Level ==subItem.Level && gr.Group.Name.ToString() == subItem.Name)
                                  {
                                   gr.IsCollapsed = subItem.IsCollapsed;
                                   items[j].subItems.Remove(subItem);
                                   return;
                                  }
                               }
                           }
                       }
                  }
             }
        }
        public ObservableCollection<Product> Products
        {
            get { return _products; }
        }
        
    }
}
